--author Michal Strnad
--title Centrální logování
--date today

--center   _____ ______  _____ _   _ ______ _______                            
--center  / ____|  ____|/ ____| \ | |  ____|__   __|                           
--center | |    | |__  | (___ |  \| | |__     | |     ____  ___   _ __   ___   
--center | |    |  __|  \___ \| . ` |  __|    | |    |_  / / __| | '_ \ / _ \  
--center | |____| |____ ____) | |\  | |____   | |     / / _\__ \_| |_) | (_) | 
--center  \_____|______|_____/|_| \_|______|  |_|    /___(_)___(_) .__(_)___(_)
--center                                                         | |           
--center                                                         |_|           
--center  _            _                       
--center | |          | |      ____            
--center | |_ ___  ___| |__   / __ \ ___ _   _ 
--center | __/ _ \/ __| '_ \ / / _` / __| | | |
--center | ||  __/ (__| | | | | (_| \__ \ |_| |
--center  \__\___|\___|_| |_|\ \__,_|___/\__,_|
--center                      \____/           
                                       
--newpage
--heading Agenda                                            
Úvod / Možnosti sběru dat

Zpracování logů / Analýza

Centrální logovaní

Závěr

--footer Michal Strnad CESNET z.s.p.o / tech@su

--newpage
--heading Proč?

* Na desktopových stanicích nám většinou stačí předvolené nastavení. 
---

* Na serverech je však situace jiná. Jako aministrátoři musíme zabezpečit vysokou dostupnost, spolehlivost a bezpečnost serverových aplikací.
Právě v takovýchto situacích bývájí nejčastějším zdrojem klasifikace problémů právě log soubory.
---

--newpage
--heading Co to je log?

* Obyčejný textový soubor - co taky jiného v GNU/Linuxu.
---

* Logy (nebo také žurnály) můzeme rozdělit na transakční a event
---

Transakční logy
* určené pro recovery po pádu systému
---

* mají zajistit konzistentní stav
---

* nejsou určené pro čtení lidmi
---

* Transakční logy nás zde nebudou zajímat.
---

--newpage
--heading Co to je log?

Event logy
* Jádro a řada systémových programů (daemonů) produkuje různe zprávy o chybách
---

* varování
---

* (ne-)očekávaných událostí
---

* či jen informace o spuštění
---

Sídlý v /var/log/*

Každý program používá jiný formát logu.
Existuje Common Log Format (NCSA Common log format), který používají webové servery.

Ukázka
--beginoutput
127.0.0.1 user-identifier frank [10/Oct/2000:13:55:36 -0700] "GET /apache_pb.gif HTTP/1.0" 200 2326
--endoutput

--newpage
--heading Velmi krátký výlet do historie

* V dávných dobách byly eventy zasílány na konzoli nebo do různých log souborů.
---

* Nejednotný systém
---

* obtížná konfigurace
---

* Potřeba vzniku centrálního daemona pro zpracování a logovaní zpráv.
---

* Dnes existuje několik různých systémů na podobném principu.
---

--newpage
--heading syslog

* Pochází z BSD
---

* Programy zapisují do soketu /dev/log
---

* Speciální proces klogd vybírá zprávy z bufferu jádra a posílá je soketem syslogu
---

Skládá se z
* syslogd - daemon
---

* openlog, syslog, closelog, vsyslog - knihovní funkce
---

* logger - logovací uživatelský příkaz
---

--newpage
--heading syslog - konfigurace

* /etc/syslog.conf
---

* Formát: selektor <tab> akce
---

* selektor=sluzba.uroven
---

* Jména služeb jsou omezena: user, mail, daemon, kern ... (zaleží na implementaci libc v OS)
---

* Úrovně: emerge, crit ... notice, debug, none a *
---

* Jména služeb a úrovní: syslog.h (/usr/include/x86_64-linux-gnu/sys/syslog.h)
---

* Příklady:
---
* auth.notice	/var/log/authlog
---
* *.debug; mail.none
---

--newpage
--heading syslog - konfigurace
Akce:

* /cesta/soubor
---

* -/cesta/soubor - bez volání sync()
---

* |/cesta/fifo - pojmenovaná roura
---

* username - na terminál uživatele
---

* * - na terminál všech uživatelů
---

* @ip-adresa - UDP paket na danou IP
---

* @jmeno - UDP paket na danou domenu
---

* @@ip-adresa - TCP paket na danou IP
---

UDP/TCP port - 514

--newpage
--heading syslog - konfigurace

* Před testem nové konfigurace je potřeba ji nejdříve načíst:
--beginoutput
/bin/kill -HUP `/bin/cat /var/run/syslog.pig`
--endoutput
---

Side-efekt příkazu je uzavření a nově otevření všech logů. To se využívá při zálohování, smazání starých či velkých log souborů.
---

* Ověření konfigurace pomocí /usr/bin/logger
---

--newpage
--heading Rsyslog
 
* Nevýhodou syslogd (co si pamatuji) je, že nepodporuje TCP syslog protokol ani žádný jiný kromě UDP.
---

* UDP nezaručuje spolehlivost a špatně se řeší na FW.
---

* Reliability můžeme zvlášť pocítit na velmi zatíženém systému/síti.
---

* lepší granularita (nastavování filterů)
---

* Fedora, Debian and Ubuntu
---


--newpage
--heading syslog-ng (new generation)

Existuje ve třech verzích (edicích)

- Open Source Edition
- Premium Edition
- Store Box Edition

Komerční varianty (Premium a Store Box) přidávají oproti open source variantě několik vlastností, například podpora SSL/TLS, ukládaní logů do databází, atd

--newpage
--heading Rotace logu

* Zajišťuje externí program, nejčastěji logrotate 
Konfig /etc/logrotate.conf
---

* Definujeme zde data retention, kompresi apod.
---

--newpage
--heading Analyza logu

Syslog a rsyslog nedělají analýzu logů. Na to lze použít např.
* logcheck
---
*	Eliminuje nezajímavé informace
---
*	Cron s implicitním nastavením 1 hod
---
*	Tři sady pravidel: kstation, server a paranoid 
---
*	Out-of-box
---
* logwatch
---
*	Nejpoužívanější nástroj pro analýzu logů
---
*	Opravdu logy analyzuje - nepošle vám stejnou zprávu 200x, ale jen sumarizaci
---
*	Cron s implicitnim nastavenim 24 hod
---
*	Drobná zákeřnost je, že /etc/logwatch/ obsahuje jen prázdné adresáře
---
*	V Debianu jsou konfiguráky v /usr/share/logwatch/default.conf
---
*	Out-of-box
---

--newpage
--heading Klasický způsob

* tail -F, multitail, grep -R, less/zless
---

* časová režie při velkém množství dat
---

* perl je pro tyto případy rychlejší, ale stále to nestačí
---

* -> pro použitelnou analýzu záznamů je potřeba použít databázi (dependency na bežící DB)
---

--newpage
--heading Centrální logovaní

* Kombinací log záznamů z více zdrojů můzeme získat
---

* další data pomocí statistické analýzy
---

* korelací mezi zdánlivě nesouvisejícími událostmi na různých serverech/zařízeních
---

* možnost pokládat dotazy nad celou sítí
---

* reportování problémů v síti
---

--newpage
--heading Centrální logování verze 1
Server side (syslog-ng)
--beginoutput
source s_net {udp(ip("0.0.0.0") port(514)); };
destination d_tfrontend1 { file("/var/log/clients/tfrontend1"); };
filter f_tfrontend1 {host("X.X.X.X");};
log { source(s_net); filter(f_tfrontend1); destination(d_tfrontend1); };
--endoutput

Client side (syslog-ng)
--beginoutput
destination centrallogging { udp("X.X.X.X" port(514)); };
log { source(src); destination(centrallogging); };
--endoutput

Client side (rsyslog)
--beginoutput
*.*                                         @X.X.X.X
--endoutput

--newpage
--heading Centrální logování verze 2

--center Testbed: Tři virtuální stroje ve VirtualBoxu.

--center Shippers + Redis + ElasticSearch + Logstash + Kibana

Redis je zde pouze pro zlepšení výkonu Logstashe.
Chová se jako buffer na log záznamy, než si je logstash zaindexuje a uloží. 
Proces se děje v RAM.

--newpage
--heading Architektura
--exec feh ./resources/architecture.png

--newpage
--heading Shipper

Klientský software, který forwarduje záznamy na centrální server

* Syslog(-ng), rsyslog
---

* logstash (nutnost JDK na PC :-( )
---

* something else?
---

--newpage
--heading Logstash

Logstash je defakto libgrock - knihovna pro zpracování textu s lepšími regulárnimi výrazy

Zajišťuje indexaci a uložení záznamů

Lze si ho předtavit jako trubku na zpracování událostí	
	input | filter | output
Mnoho pluginů

--newpage
--heading Elasticsearch
--boldon
* Full-textový vyhledávací stroj (nikoli databáze) založený na knihovně Lucene.
--boldoff
---

* Apache License 2.0
---

* Vyhledávání téměř reálném čase
---

* Distribuovaný systém - možnost vytvořit cluster
---

* Vysoká dostupnost - viz bod výše
---

* Bezschemová "DB" - struktura se vytvoří sama na základě vložených dat
---

* Komunikace probíhá skrz HTTP metody + JSON formát
---

* Kdo ho používá?
---

* Wikimedia, StumbleUpon, Mozilla, Foursquare, GitHub ...
---

--newpage
--heading Elasticsearch

Neměl by být přímo dostupný všem lidem!
- bez autentizace
- bez šifrování


--newpage
--heading Kibana #1
--exec feh ./resources/kibana_1.png

--newpage
--heading Kibana #2
--exec feh ./resources/kibana_2.png

--newpage
--heading 

- Určitě logy centralizujte a je jedno jakou metodou
- Držte si záznamy x měsíců/let zpět
- Šifrujte přenos událostí (SSL/TLS)

Alternativa k ES je mongoDB, což je dokumentově orientovaná databáze. Lze ji přes logstash nakrmit podobně jako ES.

Na analýzu a poplachy lze použít mongomine.

--center Cookbook mohu poskytnout na vyžádání.
--center Stejně tak virtuály z testovacího prostředí.
--newpage
--heading Q & A

--center Děkuji za pozornost. Otázky?

--center michal.strnad@cesnet.cz
